<template>

  <div style="height: 95vh; width: 100%">
    <l-map
        v-if="showMap"
        :zoom="zoom"
        :center="center"
        :options="mapOptions"
        @update:center="centerUpdate"
        @update:zoom="zoomUpdate"
    >
      <l-tile-layer
          :url="url"
          :attribution="attribution"
      />
      <v-marker-cluster :options="{maxClusterRadius: 50}">
        <l-marker v-for="marker in data" :key="marker.id" :lat-lng="getLatLon(marker.location.lon, marker.location.lat)">
          <l-popup>
            <CrimeInfo :city="marker.location.city" :description="marker.description" :time="marker.time" :title="marker.title" :motiv="marker.motive.name" :sources="marker.sources" :originurl="marker.origin.url" :origin="marker.origin.name"></CrimeInfo>
          </l-popup>
        </l-marker>
      </v-marker-cluster>
    </l-map>
  </div>
</template>

<script>
import { latLng } from "leaflet";
import { LMap, LTileLayer, LMarker, LPopup } from "vue2-leaflet";
import apirequest from "@/controller/apirequest";
import CrimeInfo from "@/components/CrimeInfo";
import Vue2LeafletMarkerCluster from 'vue2-leaflet-markercluster'


export default {
  name: "Example",
  components: {
    CrimeInfo,
    LMap,
    LTileLayer,
    LMarker,
    LPopup,
    'v-marker-cluster': Vue2LeafletMarkerCluster
  },
  data() {
    return {
      zoom: 5.7,
      center: latLng(51.5482, 10.25617),
      url: 'https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png',
      attribution:
          '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors',
      mapOptions: {
        zoomSnap: 0.5
      },
      showMap: true,
      data: null,
      loaded: false
    };
  },
  methods: {
    zoomUpdate(zoom) {
      this.currentZoom = zoom;
    },
    getLatLon(lat, lon){
      return latLng(lon, lat);
    },
    centerUpdate(center) {
      this.currentCenter = center;
    },
    showLongText() {
      this.showParagraph = !this.showParagraph;
    },
    innerClick() {
      alert("Click!");
    }
  },
  mounted() {
    apirequest.crimedata().then((response) => {
      this.data = response
    })
  }
};
</script>

<style>
@import "~leaflet.markercluster/dist/MarkerCluster.css";
@import "~leaflet.markercluster/dist/MarkerCluster.Default.css";
</style>

